﻿using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.Grid.Cells;
using Syncfusion.UI.Xaml.ScrollAxis;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;

namespace HighlightFilterText
{    
    public class CustomGridCellTextBoxRenderer : GridCellTextBoxRenderer
    {
        /// <summary>
        /// Create the Textblock
        /// </summary>
        /// <returns></returns>
        protected override TextBlock OnCreateDisplayUIElement()
        {
            return new CustomTextBlock();
        }

        /// <summary>
        /// Method for initialize the UI elements.
        /// </summary>
        /// <param name="rowColumnIndex">row and column index of the cell</param>
        /// <param name="uiElement">Element which is TextBlock</param>
        /// <param name="column">Column of the Cell</param>
        /// <param name="dataContext">DataContext of each row</param>

        public override void OnInitializeDisplayElement(RowColumnIndex rowColumnIndex, TextBlock uiElement, GridColumn column, object dataContext)
        {
            if (uiElement is CustomTextBlock)
            {
                var customTextBlock = uiElement as CustomTextBlock;
                customTextBlock.SetBinding(CustomTextBlock.TextProperty, column.DisplayBinding);
                var bind = new Binding() { Path = new PropertyPath("Text"), ElementName = "searchTextBox", UpdateSourceTrigger = UpdateSourceTrigger.PropertyChanged };
                //Binds the searchTextBox for highlight the text.
                customTextBlock.SetBinding(CustomTextBlock.HighlightPhraseProperty, bind);
            }
        }
    }
}
